#pragma once

#include "ModMode.h"

using namespace System;
using namespace System::Windows::Forms;




ref class MemoryEditorForm : public Form {
public:
	static MemoryEditorForm^ meForm = nullptr; // g̃O[oϐ

	TabControl^ tcME;	// ŜłPɂȂĂ^uRg[BTabPage^ǉĂ


public: 
	MemoryEditorForm() {
		// tH[ɂ̂̏
		this->Text = "MemoryEditorMod";
		this->Width = 800;
		this->Height = 600;

		SetFormIcon();

		SetTabControl();

		this->KeyPreview = true; // eRg[̃L[͂͑SătH[󂯎

		this->Shown += gcnew EventHandler(this, &MemoryEditorForm::meForm_Shown);
		this->Resize += gcnew EventHandler(this, &MemoryEditorForm::meForm_Resize);
		this->KeyDown +=  gcnew KeyEventHandler(this, &MemoryEditorForm::meForm_KeyDown);


		meForm_Resize(nullptr, nullptr);
	}

	void SetFormIcon() {
		// ̃vWFNg̃AZũ^Cv擾B
		System::Reflection::Assembly^ prj_assebmly = GetType()->Assembly;
		System::Resources::ResourceManager^ r = gcnew System::Resources::ResourceManager(String::Format("{0}.MemoryEditorMod", prj_assebmly->GetName()->Name), prj_assebmly);


		System::Drawing::Icon^ iconform = (System::Drawing::Icon^)(r->GetObject("MemoryEditorIcon"));
		this->Icon = iconform;
	}

	// ^uRg[̏BԂɁAef[^Obhr[ւ̃f[^ݏ荞
	void SetTabControl() {
		tcME = gcnew TabControl();

		dgvYear_Init();
		dgvTurn_Init();
		dgvBushouName_Init();
		dgvBushou_Init();
		dgvDaimyo_Init();
		dgvDaimyoYuko_Init();
		dgvGundan_Init();
		dgvCastle_Init();
		dgvCastleAdd_Init();
		dgvChiiki_Init();
		dgvKanni_Init();
		dgvKahou_Init();
		dgvSoba_Init();

		dgvBattleUnit_Init();
		dgvWeather_Init();
		dgvSettings_Init();
		dgvSettingsEx_Init();
		dgvBGM_Init();

		tcME->SelectedIndexChanged += gcnew EventHandler(this, &MemoryEditorForm::tcME_SelectedIndexChanged);
		this->Controls->Add(tcME);
	}


	// ^u؂ւ
	void tcME_SelectedIndexChanged(Object^ sender, EventArgs^ e) {
		int iTabIndex = tcME->SelectedIndex;
		TabPage^ tpCur = tcME->TabPages[iTabIndex];

		if ( tpCur->Text == "pN" ) {
			dgvYear_DataImport();
		}
		else if ( tpCur->Text == "p^[" ) {
			dgvTurn_DataImport();
		}
		else if ( tpCur->Text == "pːЏ" ) {
			dgvBushouName_DataImport();
		}
		else if ( tpCur->Text == "p" ) {
			dgvBushou_DataImport();
		}
		else if ( tpCur->Text == "p喼" ) {
			dgvDaimyo_DataImport();
		}
		else if ( tpCur->Text == "p喼ij" ) {
			dgvDaimyoYuko_DataImport();
		}
		else if ( tpCur->Text == "pRc" ) {
			dgvGundan_DataImport();
		}
		else if ( tpCur->Text == "p" ) {
			dgvCastle_DataImport();
		}
		else if ( tpCur->Text == "pt" ) {
			dgvCastleAdd_DataImport();
		}
		else if ( tpCur->Text == "pn" ) {
			dgvChiiki_DataImport();
		}
		else if ( tpCur->Text == "pʏ" ) {
			dgvKanni_DataImport();
		}
		else if ( tpCur->Text == "pƕ" ) {
			dgvKahou_DataImport();
		}
		else if ( tpCur->Text == "p" ) {
			dgvSoba_DataImport();
		}
		else if ( tpCur->Text == "ij" ) {
			dgvBattleUnit_DataImport();
		}
		else if ( tpCur->Text == "pVC" ) {
			dgvWeather_DataImport();
		}
		else if ( tpCur->Text == "pݒ" ) {
			dgvSettings_DataImport();
		}
		else if ( tpCur->Text == "pݒg" ) {
			dgvSettingsEx_DataImport();
		}
		else if ( tpCur->Text == "py" ) {
			dgvBGM_DataImport();
		}

		meForm_Resize(sender, e);

	}

private:
	void meForm_Shown(Object^ sender, EventArgs^ e) {
		meForm_Resize(sender, e);
	}

	// z[TCYύXA^uRg[̃TCYύXAɊeAf[^Obhr[̑傫ύXB
	void meForm_Resize(Object^ sender, EventArgs^ e) {
		tcME->Size = this->ClientSize;

		dgvYear->Size = tpYear->ClientSize;
		dgvTurn->Size = tpTurn->ClientSize;
		dgvBushouName->Size = tpBushouName->ClientSize;
		dgvBushou->Size = tpBushou->ClientSize;
		dgvDaimyo->Size = tpDaimyo->ClientSize;
		dgvDaimyoYuko->Size = tpDaimyoYuko->ClientSize;
		dgvGundan->Size = tpGundan->ClientSize;
		dgvCastle->Size = tpCastle->ClientSize;
		dgvCastleAdd->Size = tpCastleAdd->ClientSize;
		dgvChiiki->Size = tpChiiki->ClientSize;
		dgvKanni->Size = tpKanni->ClientSize;
		dgvKahou->Size = tpKahou->ClientSize;
		dgvSoba->Size = tpSoba->ClientSize;
		dgvBattleUnit->Size = tpBattleUnit->ClientSize;
		dgvWeather->Size = tpWeather->ClientSize;
		dgvSettings->Size = tpSettings->ClientSize;
		dgvSettingsEx->Size = tpSettingsEx->ClientSize;
		dgvBGM->Size = tpBGM->ClientSize;

	}

	// F5L[ꂽAY^uĴƓuf[^XVv܂B
	void meForm_KeyDown(Object^ sender, KeyEventArgs^ e) {
		if ( Form::ActiveForm == this && e->KeyCode == ::Keys::F5 ) {
			tcME_SelectedIndexChanged(nullptr, nullptr);
		}
	}

//-------------------------------------------------- pːЏ-------------------------------------------------
private: 

	TabPage^ tpBushouName;
	DataGridView^ dgvBushouName;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleBushouName = {
		"yzpz", 
		"ԍ",
		"Get_",
		"Get_O",
		"ԍ",
		"",
		"g",
		"",
		"ދp",
		"펀",
	}; 

	void dgvBushouName_Init() {
		tpBushouName = gcnew TabPage();
		tpBushouName->Text = "pːЏ";
		tpBushouName->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpBushouName);


		// f[^ObhŜ̃CX^X 
		dgvBushouName = gcnew DataGridView();
		dgvBushouName->Size = tpBushouName->Size;
		dgvBushouName->ScrollBars = ::ScrollBars::Both;
		dgvBushouName->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleBushouName->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleBushouName[i]; 

			if ( i <= 3 ) {
				dgvtbc->Frozen = true; // OR炢͌Œ肷B
			}
			// Obhr[ɏcƂĒǉB 
			dgvBushouName->Columns->Add(dgvtbc); 
		} 

		dgvBushouName_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvBushouName->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvBushouName_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpBushouName->Controls->Add(dgvBushouName);
	} 

private: 
	void dgvBushouName_DataImport() { 
		dgvBushouName->Rows->Clear();

		for ( int i=0; i<ő吔::::z; i++) { 
			dgvBushouName->Rows->Add( 
				i,
				i+1,
				gcnew String(Get_(i).c_str()), 
				gcnew String(Get_O(i).c_str()), 
				pːЏ[i].ԍ,
				pːЏ[i].,
				pːЏ[i].g,
				pːЏ[i].,
				pːЏ[i].ދp,
				pːЏ[i].펀
			); 
		} 
	} 

	void dgvBushouName_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvBushouName->Columns[e->ColumnIndex]->HeaderText;



		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlAԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iBushouID = Convert::ToInt32(dgvBushouName[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvBushouName[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "Get_") {
			char szName[32] = "";
			wsprintf(szName, "%s", svalue);
			Set_( iBushouID, szName );
		} 
		else if (headerText == "Get_O") { 
			char szName[32] = "";
			wsprintf(szName, "%s", svalue);
			Set_O( iBushouID, szName );
		} 
		else if (headerText == "ԍ") { 
			pːЏ[iBushouID].ԍ = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "") { 
			pːЏ[iBushouID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "g") { 
			pːЏ[iBushouID].g = Convert::ToByte(svalue); 
		} 
		else if (headerText == "") { 
			pːЏ[iBushouID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "ދp") { 
			pːЏ[iBushouID].ދp = Convert::ToByte(svalue); 
		} 
		else if (headerText == "펀") { 
			pːЏ[iBushouID].펀 = Convert::ToByte(svalue); 
		} 
	} 


//-------------------------------------------------- pːЏ-------------------------------------------------


//-------------------------------------------------- p-------------------------------------------------
private: 

	TabPage^ tpBushou;
	DataGridView^ dgvBushou;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleBushou;

	static cli::array<String^>^ getColTitleBushou() {
		if (iCallDLLMODE == kModeTSMod) {
			cli::array<String^>^ ret = {
				"yzpz",
				"ԍ",
				"O̕yԍz",
				"̕yԍz",
				"ő吭",
				"ő",
				"őq",
				"nl",
				"퓬nl",
				"qdnl",
				"",
				"]",
				"",
				"M",
				"",
				"喼y喼ԍz",
				"RcyRcԍz",
				"yԍz",
				"喼y喼ԍz",
				"",
				"P",
				"mC",
				"",
				"dN",
				"Get_ԍyzpz",
				"N",
				"eԍ",
				"vl",
				"`",
				"",
				"K",
				"퓬K",
				"qdK",
				"Z\ꊅ",
				"Z\ÎE",
				"Z\o",
				"Z\",
				"Z\",
				"Z\ِ",
				"Z\ē",
				"Z\",
				"E",
				"yK",
				"RnK",
				"Get_SCK",
				"RK",
				"Get_|K", // Ă
				"Get_K", // Ă
				"C",
				"RnSC",
				"SbD",
				"",
				"E",
				"Get_Ɨ",
				"",
				"s",
				"",
				"⍦",
				"",
				"Is_vCS"
			};

			return ret;
		} 
		else {
			cli::array<String^>^ ret = {
				"yzpz",
				"ԍ",
				"O̕yԍz",
				"̕yԍz",
				"ő吭",
				"ő",
				"őq",
				"nl",
				"퓬nl",
				"qdnl",
				"",
				"]",
				"",
				"M",
				"",
				"喼y喼ԍz",
				"RcyRcԍz",
				"yԍz",
				"喼y喼ԍz",
				"",
				"P",
				"mC",
				"",
				"dN",
				"Get_ԍyzpz",
				"N",
				"eԍ",
				"vl",
				"`",
				"",
				"K",
				"퓬K",
				"qdK",
				"Z\ꊅ",
				"Z\ÎE",
				"Z\o",
				"Z\",
				"Z\",
				"Z\ِ",
				"Z\ē",
				"Z\",
				"E",
				"yK",
				"RnK",
				"Get_SCK",
				"RK",
				"C",
				"RnSC",
				"SbD",
				"",
				"E",
				"Get_Ɨ",
				"",
				"s",
				"",
				"⍦",
				"",
				"Is_vCS"
			};

			return ret;
		}
	}

	void dgvBushou_Init() {
		// TSModPluginModōڐقȂ
		colTitleBushou = getColTitleBushou();

		tpBushou = gcnew TabPage();
		tpBushou->Text = "p";
		tpBushou->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpBushou);


		// f[^ObhŜ̃CX^X 
		dgvBushou = gcnew DataGridView();
		dgvBushou->Size = tpBushou->Size;
		dgvBushou->ScrollBars = ::ScrollBars::Both;
		dgvBushou->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleBushou->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleBushou[i]; 

			if ( i <= 1 ) {
				dgvtbc->Frozen = true; // OR炢͌Œ肷B
			}
			// Obhr[ɏcƂĒǉB 
			dgvBushou->Columns->Add(dgvtbc); 
		} 

		dgvBushou_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvBushou->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvBushou_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpBushou->Controls->Add(dgvBushou);
	} 

private: 
	void dgvBushou_DataImport() { 
		dgvBushou->Rows->Clear();

		// TSModPluginModōڐقȂ
		if (iCallDLLMODE == kModeTSMod) {
			// PʂőĂ䂭Aindex:0, :1, :2, :3 퓬:4 qd:5 ̏Ԓʂ 
			for (int i = 0; i < ő吔::::z; i++) {
				dgvBushou->Rows->Add(
					i,
					i + 1,
					p[i].O̕yԍz,
					p[i].̕yԍz,
					p[i].ő吭,
					p[i].ő,
					p[i].őq,
					p[i].nl,
					p[i].퓬nl,
					p[i].qdnl,
					p[i].,
					p[i].],
					p[i].,
					p[i].M,
					p[i].,
					p[i].喼y喼ԍz,
					p[i].RcyRcԍz,
					p[i].yԍz,
					p[i].喼y喼ԍz,
					p[i].,
					p[i].P,
					p[i].mC,
					p[i].,
					p[i].dN,
					Get_ԍyzpz(i),
					p[i].N,
					p[i].eԍ,
					p[i].vl,
					p[i].`,
					p[i].,
					p[i].K,
					p[i].퓬K,
					p[i].qdK,
					p[i].Z\ꊅ,
					p[i].Z\ÎE,
					p[i].Z\o,
					p[i].Z\,
					p[i].Z\,
					p[i].Z\ِ,
					p[i].Z\ē,
					p[i].Z\,
					p[i].E,
					p[i].yK,
					p[i].RnK,
					Get_SCK(i),
					p[i].RK,
					Get_|K(i),  // Ă
					Get_K(i),  // Ă
					p[i].C,
					p[i].RnSC,
					p[i].SbD,
					p[i].,
					p[i].E,
					Get_Ɨ(i),
					p[i].,
					p[i].s,
					p[i].,
					p[i].⍦,
					p[i].,
					Is_vCS(i)
				);
			}
		}
		else {
			// PʂőĂ䂭Aindex:0, :1, :2, :3 퓬:4 qd:5 ̏Ԓʂ 
			for (int i = 0; i < ő吔::::z; i++) {
				dgvBushou->Rows->Add(
					i,
					i + 1,
					p[i].O̕yԍz,
					p[i].̕yԍz,
					p[i].ő吭,
					p[i].ő,
					p[i].őq,
					p[i].nl,
					p[i].퓬nl,
					p[i].qdnl,
					p[i].,
					p[i].],
					p[i].,
					p[i].M,
					p[i].,
					p[i].喼y喼ԍz,
					p[i].RcyRcԍz,
					p[i].yԍz,
					p[i].喼y喼ԍz,
					p[i].,
					p[i].P,
					p[i].mC,
					p[i].,
					p[i].dN,
					Get_ԍyzpz(i),
					p[i].N,
					p[i].eԍ,
					p[i].vl,
					p[i].`,
					p[i].,
					p[i].K,
					p[i].퓬K,
					p[i].qdK,
					p[i].Z\ꊅ,
					p[i].Z\ÎE,
					p[i].Z\o,
					p[i].Z\,
					p[i].Z\,
					p[i].Z\ِ,
					p[i].Z\ē,
					p[i].Z\,
					p[i].E,
					p[i].yK,
					p[i].RnK,
					Get_SCK(i),
					p[i].RK,
					p[i].C,
					p[i].RnSC,
					p[i].SbD,
					p[i].,
					p[i].E,
					Get_Ɨ(i),
					p[i].,
					p[i].s,
					p[i].,
					p[i].⍦,
					p[i].,
					Is_vCS(i)
				);
			}
		}
	} 

	void dgvBushou_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvBushou->Columns[e->ColumnIndex]->HeaderText;



		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlAԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iBushouID = Convert::ToInt32(dgvBushou[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvBushou[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "ő吭") { 
			// ỸObh̒lbyte^(256܂ł̌^)ɂāApɑB 
			p[iBushouID].ő吭 = Convert::ToByte(svalue); 
		} 
		else if (headerText == "ő") { 
			p[iBushouID].ő = Convert::ToByte(svalue); 
		} 
		else if (headerText == "őq") { 
			p[iBushouID].őq = Convert::ToByte(svalue); 
		} 
		else if (headerText == "nl") { 
			p[iBushouID].nl = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "퓬nl") { 
			p[iBushouID].퓬nl = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "qdnl") { 
			p[iBushouID].qdnl = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "") { 
			p[iBushouID]. = Convert::ToSByte(svalue); 
		} 
		else if (headerText == "]") { 
			p[iBushouID].] = Convert::ToSByte(svalue); 
		} 
		else if (headerText == "") { 
			p[iBushouID]. = Convert::ToSByte(svalue); 
		} 
		else if (headerText == "M") { 
			p[iBushouID].M = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "") { 
			p[iBushouID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "喼y喼ԍz") { 
			p[iBushouID].喼y喼ԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "RcyRcԍz") { 
			p[iBushouID].RcyRcԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "yԍz") { 
			p[iBushouID].yԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "喼y喼ԍz") { 
			p[iBushouID].喼y喼ԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "") { 
			p[iBushouID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "P") { 
			p[iBushouID].P = Convert::ToByte(svalue); 
		} 
		else if (headerText == "mC") { 
			p[iBushouID].mC = Convert::ToByte(svalue); 
		} 
		else if (headerText == "") { 
			p[iBushouID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "dN") { 
			p[iBushouID].dN = Convert::ToByte(svalue); 
		} 
		else if (headerText == "N") { 
			p[iBushouID].N = Convert::ToByte(svalue); 
		} 
		else if (headerText == "eԍ") { 
			p[iBushouID].eԍ = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "vl") { 
			p[iBushouID].vl = Convert::ToByte(svalue); 
		} 
		else if (headerText == "`") { 
			p[iBushouID].` = Convert::ToByte(svalue); 
		} 
		else if (headerText == "") { 
			p[iBushouID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "K") { 
			p[iBushouID].K = Convert::ToByte(svalue); 
		} 
		else if (headerText == "퓬K") { 
			p[iBushouID].퓬K = Convert::ToByte(svalue); 
		} 
		else if (headerText == "qdK") { 
			p[iBushouID].qdK = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Z\ꊅ") { 
			p[iBushouID].Z\ꊅ = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Z\ÎE") { 
			p[iBushouID].Z\ÎE = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Z\o") { 
			p[iBushouID].Z\o = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Z\") { 
			p[iBushouID].Z\ = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Z\") { 
			p[iBushouID].Z\ = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Z\ِ") { 
			p[iBushouID].Z\ِ = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Z\ē") { 
			p[iBushouID].Z\ē = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Z\") { 
			p[iBushouID].Z\ = Convert::ToByte(svalue); 
		} 
		else if (headerText == "E") { 
			p[iBushouID].E = Convert::ToByte(svalue); 
		} 
		else if (headerText == "yK") { 
			p[iBushouID].yK = Convert::ToByte(svalue); 
		} 
		else if (headerText == "RnK") { 
			p[iBushouID].RnK = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Get_SCK") { 
			Set_SCK(iBushouID, Convert::ToByte(svalue) ); 
		} 
		else if (headerText == "RK") {
			p[iBushouID].RK = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Get_|K") {
			Set_|K(iBushouID, Convert::ToByte(svalue));
		}
		else if (headerText == "Get_K") {
			Set_K(iBushouID, Convert::ToByte(svalue));
		}
		else if (headerText == "C") { 
			p[iBushouID].C = Convert::ToByte(svalue); 
		} 
		else if (headerText == "RnSC") { 
			p[iBushouID].RnSC = Convert::ToByte(svalue); 
		} 
		else if (headerText == "SbD") { 
			p[iBushouID].SbD = Convert::ToByte(svalue); 
		} 
		else if (headerText == "") { 
			p[iBushouID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "E") { 
			p[iBushouID].E = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Get_Ɨ") { 
			Set_Ɨ( iBushouID, Convert::ToByte(svalue) ); 
		} 
		else if (headerText == "") { 
			p[iBushouID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "s") { 
			p[iBushouID].s = Convert::ToByte(svalue); 
		} 
		else if (headerText == "") { 
			p[iBushouID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "⍦") { 
			p[iBushouID].⍦ = Convert::ToByte(svalue); 
		} 
		else if (headerText == "") { 
			p[iBushouID]. = Convert::ToByte(svalue); 
		} 
	} 


//-------------------------------------------------- p-------------------------------------------------


//-------------------------------------------------- pN-------------------------------------------------
private: 

	TabPage^ tpYear;
	DataGridView^ dgvYear;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleYear = {
		"N", 
		"G",
		"Get_",
		"Get_a",
		"Get_VċLN",
	}; 

	void dgvYear_Init() {
		tpYear = gcnew TabPage();
		tpYear->Text = "pN";
		tpYear->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpYear);


		// f[^ObhŜ̃CX^X 
		dgvYear = gcnew DataGridView();
		dgvYear->Size = tpYear->Size;
		dgvYear->ScrollBars = ::ScrollBars::Both;
		dgvYear->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleYear->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleYear[i]; 

			// Obhr[ɏcƂĒǉB 
			dgvYear->Columns->Add(dgvtbc); 
		} 

		dgvYear_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvYear->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvYear_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpYear->Controls->Add(dgvYear);
	} 

private: 
	void dgvYear_DataImport() { 
		dgvYear->Rows->Clear();

		a^ wa = Get_a( Get_() );
		string ƔN = wa. + wa.N;

		dgvYear->Rows->Add( 
			pN.N,
			pN.G,
			Get_(),
			gcnew String( ƔN.c_str() ),
			Get_VċLN()
		); 
	} 

	void dgvYear_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvYear->Columns[e->ColumnIndex]->HeaderText;

		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlA^[ԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iBushouID = Convert::ToInt32(dgvYear[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvYear[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "N") { 
			pN.N = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "G") { 
			pN.G = Convert::ToSByte(svalue); 
		} 


	} 


//-------------------------------------------------- pN-------------------------------------------------


//-------------------------------------------------- p^[-------------------------------------------------
private: 

	TabPage^ tpTurn;
	DataGridView^ dgvTurn;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleTurn = {
		"݂̃^[y喼ԍz", 
		"݂̃^[yRcԍz",
		"݂̃^[yԍz",
	}; 

	void dgvTurn_Init() {
		tpTurn = gcnew TabPage();
		tpTurn->Text = "p^[";
		tpTurn->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpTurn);


		// f[^ObhŜ̃CX^X 
		dgvTurn = gcnew DataGridView();
		dgvTurn->Size = tpTurn->Size;
		dgvTurn->ScrollBars = ::ScrollBars::Both;
		dgvTurn->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleTurn->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleTurn[i]; 

			// Obhr[ɏcƂĒǉB 
			dgvTurn->Columns->Add(dgvtbc); 
		} 

		dgvTurn_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvTurn->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvTurn_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpTurn->Controls->Add(dgvTurn);
	} 

private: 
	void dgvTurn_DataImport() { 
		dgvTurn->Rows->Clear();

		dgvTurn->Rows->Add( 
			p^[.݂̃^[y喼ԍz,
			p^[.݂̃^[yRcԍz,
			p^[.݂̃^[yԍz
		); 
	} 

	void dgvTurn_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvTurn->Columns[e->ColumnIndex]->HeaderText;

		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlA^[ԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iBushouID = Convert::ToInt32(dgvTurn[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvTurn[e->ColumnIndex, e->RowIndex]->Value->ToString();
	} 


//-------------------------------------------------- p^[-------------------------------------------------


//-------------------------------------------------- p喼-------------------------------------------------
private: 

	TabPage^ tpDaimyo;
	DataGridView^ dgvDaimyo;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleDaimyo = {
		"yzpz", 
		"喼ԍ",
		"喼yԍz",
		"RcyRcԍz",
		"yԍz",
		"Byԍz",
		"Ɩ",
		"GΑ喼y喼ԍz",
		"FD喼y喼ԍz",
		"l",
		"z",
		"]",
		"Get_喼E",
		"Get_喼鐔",
		"Is_vCS喼",
	}; 


	void dgvDaimyo_Init() {
		tpDaimyo = gcnew TabPage();
		tpDaimyo->Text = "p喼";
		tpDaimyo->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpDaimyo);


		// f[^ObhŜ̃CX^X 
		dgvDaimyo = gcnew DataGridView();
		dgvDaimyo->Size = tpDaimyo->Size;
		dgvDaimyo->ScrollBars = ::ScrollBars::Both;
		dgvDaimyo->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleDaimyo->Length; i++) {

			
			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleDaimyo[i]; 
			if ( i <= 1 ) {
				dgvtbc->Frozen = true; // OR炢͌Œ肷B
			}
			// Obhr[ɏcƂĒǉB 
			dgvDaimyo->Columns->Add(dgvtbc); 

		} 

		dgvDaimyo_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvDaimyo->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvDaimyo_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpDaimyo->Controls->Add(dgvDaimyo);
	} 

private: 
	void dgvDaimyo_DataImport() {

		dgvDaimyo->Rows->Clear();

		for ( int i=0; i<ő吔::喼::z; i++) {

			dgvDaimyo->Rows->Add( 
				i,
				i+1,
				p喼[i].喼yԍz,
				p喼[i].RcyRcԍz,
				p喼[i].yԍz,
				p喼[i].Byԍz,
				p喼[i].Ɩ,
				p喼[i].GΑ喼y喼ԍz,
				p喼[i].FD喼y喼ԍz,
				p喼[i].l,
				p喼[i].z,
				p喼[i].],
				Get_喼E( i ),
				Get_喼鐔(i),
				Is_vCS喼(i)
			); 
		}

	} 

	void dgvDaimyo_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvDaimyo->Columns[e->ColumnIndex]->HeaderText;



		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlA喼ԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iDaimyoID = Convert::ToInt32(dgvDaimyo[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvDaimyo[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "喼yԍz") { 
			p喼[iDaimyoID].喼yԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "RcyRcԍz") { 
			p喼[iDaimyoID].RcyRcԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "yԍz") { 
			p喼[iDaimyoID].yԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "Byԍz") { 
			p喼[iDaimyoID].Byԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "Ɩ") { 
			p喼[iDaimyoID].Ɩ = Convert::ToByte(svalue); 
		} 
		else if (headerText == "GΑ喼y喼ԍz") { 
			p喼[iDaimyoID].GΑ喼y喼ԍz = Convert::ToByte(svalue); 
		} 
		else if (headerText == "FD喼y喼ԍz") { 
			p喼[iDaimyoID].FD喼y喼ԍz = Convert::ToByte(svalue); 
		} 
		else if (headerText == "l") { 
			p喼[iDaimyoID].l = Convert::ToByte(svalue); 
		} 
		else if (headerText == "z") { 
			p喼[iDaimyoID].z = Convert::ToByte(svalue); 
		} 
		else if (headerText == "]") { 
			p喼[iDaimyoID].] = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Ɩ") { 
			p喼[iDaimyoID].Ɩ = Convert::ToByte(svalue); 
		} 
	} 


//-------------------------------------------------- p喼-------------------------------------------------


//-------------------------------------------------- p喼ij-------------------------------------------------
private: 

	TabPage^ tpDaimyoYuko;
	DataGridView^ dgvDaimyoYuko;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleDaimyoYuko = {
		"yzpz", 
		"喼ԍ",
		"EEFD",
	}; 

	DataGridViewComboBoxColumn^ dgvDKYtbc;

	void dgvDaimyoYuko_Init() {
		tpDaimyoYuko = gcnew TabPage();
		tpDaimyoYuko->Text = "p喼ij";
		tpDaimyoYuko->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpDaimyoYuko);


		// f[^ObhŜ̃CX^X 
		dgvDaimyoYuko = gcnew DataGridView();
		dgvDaimyoYuko->Size = tpDaimyoYuko->Size;
		dgvDaimyoYuko->ScrollBars = ::ScrollBars::Both;

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleDaimyoYuko->Length; i++) {

			if ( colTitleDaimyoYuko[i] == "EEFD" ) {
				// R{{bNX̃IuWFNg 
				dgvDKYtbc = gcnew DataGridViewComboBoxColumn(); 

				// ^Cgݒ 
				dgvDKYtbc->HeaderText = colTitleDaimyoYuko[i];

				dgvDKYtbc->Width = 270;

				// Obhr[ɏcƂĒǉB 
				dgvDaimyoYuko->Columns->Add(dgvDKYtbc); 

			} else {
				// c̃IuWFNg 
				DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
				// ^Cgݒ 
				dgvtbc->HeaderText = colTitleDaimyoYuko[i]; 
				if ( i <= 1 ) {
					dgvtbc->Frozen = true; // OR炢͌Œ肷B
				}
				// Obhr[ɏcƂĒǉB 
				dgvDaimyoYuko->Columns->Add(dgvtbc); 
			}

		} 

		dgvDaimyoYuko_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvDaimyoYuko->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvDaimyoYuko_CellValueChanged); 
		dgvDaimyoYuko->DataError += gcnew DataGridViewDataErrorEventHandler(this, &MemoryEditorForm::dgvDaimyoYuko_DataError); 
		dgvDaimyoYuko->CellMouseEnter += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvDaimyoYuko_CellMouseEnter); 

		// f[^Obhr[tH[ɏ 
		tpDaimyoYuko->Controls->Add(dgvDaimyoYuko);
	} 

	//DataErrorCxgnh
	void dgvDaimyoYuko_DataError(Object^ sender, DataGridViewDataErrorEventArgs^ e) {
		e->Cancel = false;
	}

private: 
	void dgvDaimyoYuko_DataImport() {

		dgvDaimyoYuko->Rows->Clear();

		for ( int i=0; i<ő吔::喼::z; i++) {

			dgvDaimyoYuko->Rows->Add( 
				i,
				i+1
			); 
		}

	} 

	void dgvDaimyoYuko_CellMouseEnter(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		if ( 0 <= e->ColumnIndex && e->ColumnIndex <= 3 &&
			0 <= e->RowIndex && e->RowIndex < ő吔::喼::z ) {

			String^ headerText = dgvDaimyoYuko->Columns[e->ColumnIndex]->HeaderText;

			int iDaimyoID = Convert::ToInt32(dgvDaimyoYuko[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

			if ( headerText == "EEFD" ) {

				BindingSource^ bs = gcnew BindingSource();

				for ( int iTargetDaimyoYukoID=0; iTargetDaimyoYukoID < ő吔::喼::z; iTargetDaimyoYukoID++ ) {
					String^ y_d_k = String::Format("喼ԍ: {0,2} | FD: {1,2} | :{2} | :{3}",
												iTargetDaimyoYukoID + 1,
												Get_FD֌W(iDaimyoID, iTargetDaimyoYukoID),
												Is_֌W(iDaimyoID, iTargetDaimyoYukoID) ? "" : "~",
												Is_֌W(iDaimyoID, iTargetDaimyoYukoID) ? "" : "~" );
					bs->Add(y_d_k);

					dgvDKYtbc->DataSource = bs;
				}
			}
		}
	}

	void dgvDaimyoYuko_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvDaimyoYuko->Columns[e->ColumnIndex]->HeaderText;



		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlA喼ԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iDaimyoYukoID = Convert::ToInt32(dgvDaimyoYuko[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvDaimyoYuko[e->ColumnIndex, e->RowIndex]->Value->ToString();
	} 


//-------------------------------------------------- p喼ij-------------------------------------------------

//-------------------------------------------------- pRc-------------------------------------------------
private: 

	TabPage^ tpGundan;
	DataGridView^ dgvGundan;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleGundan = {
		"yzpz", 
		"Rcԍ",
		"ǑRcyRcԍz",
		"̌RcyRcԍz",
		"yԍz",
		"喼y喼ԍz",
		"s",
		"",
		"",
		"n",
		"SC",
		"Rcԍ",
		"Get_Rc",
		"Get_RcE",
		"Get_Rtԍyzpz",
		"Get_Rc鐔",
		"Is_vCSRc",
	}; 

	void dgvGundan_Init() {
		tpGundan = gcnew TabPage();
		tpGundan->Text = "pRc";
		tpGundan->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpGundan);


		// f[^ObhŜ̃CX^X 
		dgvGundan = gcnew DataGridView();
		dgvGundan->Size = tpGundan->Size;
		dgvGundan->ScrollBars = ::ScrollBars::Both;
		dgvGundan->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleGundan->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleGundan[i]; 

			if ( i <= 1 ) {
				dgvtbc->Frozen = true; // OR炢͌Œ肷B
			}
			// Obhr[ɏcƂĒǉB 
			dgvGundan->Columns->Add(dgvtbc); 
		} 

		dgvGundan_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvGundan->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvGundan_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpGundan->Controls->Add(dgvGundan);
	} 

private: 
	void dgvGundan_DataImport() { 

		dgvGundan->Rows->Clear();

		for ( int i=0; i<ő吔::Rc::z; i++) { 
			dgvGundan->Rows->Add( 
				i,
				i+1,
				pRc[i].ǑRcyRcԍz,
				pRc[i].̌RcyRcԍz,
				pRc[i].yԍz,
				pRc[i].喼y喼ԍz,
				pRc[i].s,
				pRc[i].,
				pRc[i].,
				pRc[i].n,
				pRc[i].SC,
				pRc[i].Rcԍ,
				Get_Rc(i),
				Get_RcE(i),
				Get_Rtԍyzpz(i),
				Get_Rc鐔(i),
				Is_vCSRc(i)
				
			); 
		} 
	} 

	void dgvGundan_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvGundan->Columns[e->ColumnIndex]->HeaderText;



		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlARcԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iGundanID = Convert::ToInt32(dgvGundan[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvGundan[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "ǑRcyRcԍz") { 
			pRc[iGundanID].ǑRcyRcԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "̌RcyRcԍz") { 
			pRc[iGundanID].̌RcyRcԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "yԍz") { 
			pRc[iGundanID].yԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "喼y喼ԍz") { 
			pRc[iGundanID].喼y喼ԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "s") { 
			pRc[iGundanID].s = Convert::ToByte(svalue); 
		} 
		else if (headerText == "") { 
			pRc[iGundanID]. = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "") { 
			pRc[iGundanID]. = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "n") { 
			pRc[iGundanID].n = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "SC") { 
			pRc[iGundanID].SC = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "Rcԍ") { 
			pRc[iGundanID].Rcԍ = Convert::ToByte(svalue); 
		} 
	} 
//-------------------------------------------------- pRc-------------------------------------------------



//-------------------------------------------------- p-------------------------------------------------
private: 

	TabPage^ tpCastle;
	DataGridView^ dgvCastle;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleCastle = {
		"yzpz", 
		"ԍ",
		"Get_閼",
		"Ȍyԍz",
		"̏yԍz",
		"yԍz",
		"_Ql擪yԍz",
		"RcyRcԍz",
		"s",
		"΍",
		"",
		"l",
		"",
		"",
		"",
		"{",
		"b",
		"nYn",
		"`",
		"ۍ`",
		"R",
		"R",
		"R",
		"Gwi",
		"Get_",
		"",
		"_OύX"
	}; 

	void dgvCastle_Init() {
		tpCastle = gcnew TabPage();
		tpCastle->Text = "p";
		tpCastle->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpCastle);


		// f[^ObhŜ̃CX^X 
		dgvCastle = gcnew DataGridView();
		dgvCastle->Size = tpCastle->Size;
		dgvCastle->ScrollBars = ::ScrollBars::Both;
		dgvCastle->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleCastle->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleCastle[i]; 

			if ( i <= 2 ) {
				dgvtbc->Frozen = true; // OR炢͌Œ肷B
			}
			// Obhr[ɏcƂĒǉB 
			dgvCastle->Columns->Add(dgvtbc); 
		} 

		dgvCastle_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvCastle->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvCastle_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpCastle->Controls->Add(dgvCastle);
	} 

private: 
	void dgvCastle_DataImport() { 

		dgvCastle->Rows->Clear();

		for ( int i=0; i<ő吔::::z; i++) { 
			dgvCastle->Rows->Add( 
				i,
				i+1,
				gcnew String(Get_閼(i).c_str()),

				p[i].Ȍyԍz,
				p[i].̏yԍz,
				p[i].yԍz,
				p[i]._Ql擪yԍz,
				p[i].RcyRcԍz,
				p[i].s,
				p[i].΍,
				p[i].,
				p[i].l,
				p[i].,
				p[i].,
				p[i].,
				p[i].{,
				p[i].b,
				p[i].nYn,
				p[i].`,
				p[i].ۍ`,
				p[i].R,
				p[i].R,
				p[i].R,
				p[i].Gwi,
				gcnew String(Get_(i).c_str()),
				p[i].,
				p[i]._OύX
			
			); 
		} 
	} 

	void dgvCastle_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvCastle->Columns[e->ColumnIndex]->HeaderText;



		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlAԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iCastleID = Convert::ToInt32(dgvCastle[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvCastle[e->ColumnIndex, e->RowIndex]->Value->ToString();



		if (headerText == "Get_閼") { 
			char szName[32] = "";
			wsprintf(szName, "%s", svalue);
			Set_閼( iCastleID, szName );
		} 
		else if (headerText == "Ȍyԍz") { 
			p[iCastleID].Ȍyԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "̏yԍz") { 
			p[iCastleID].̏yԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "yԍz") { 
			p[iCastleID].yԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "_Ql擪yԍz") { 
			p[iCastleID]._Ql擪yԍz = Convert::ToUInt16(svalue); 
		} 

		else if (headerText == "RcyRcԍz") { 
			p[iCastleID].RcyRcԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "s") { 
			p[iCastleID].s = Convert::ToByte(svalue); 
		} 
		else if (headerText == "") { 
			p[iCastleID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "l") { 
			p[iCastleID].l = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "") { 
			p[iCastleID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "") { 
			p[iCastleID]. = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "") { 
			p[iCastleID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "{") { 
			p[iCastleID].{ = Convert::ToByte(svalue); 
		} 
		else if (headerText == "b") { 
			p[iCastleID].b = Convert::ToByte(svalue); 
		} 
		else if (headerText == "nYn") { 
			p[iCastleID].nYn = Convert::ToByte(svalue); 
		} 
		else if (headerText == "`") { 
			p[iCastleID].` = Convert::ToByte(svalue); 
		} 
		else if (headerText == "ۍ`") { 
			p[iCastleID].ۍ` = Convert::ToByte(svalue); 
		} 
		else if (headerText == "R") { 
			p[iCastleID].R = Convert::ToByte(svalue); 
		} 

		else if (headerText == "R") { 
			p[iCastleID].R = Convert::ToByte(svalue); 
		} 
		else if (headerText == "R") { 
			p[iCastleID].R = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Gwi") { 
			p[iCastleID].Gwi = Convert::ToByte(svalue); 
		} 
		else if (headerText == "") { 
			p[iCastleID]. = Convert::ToByte(svalue); 
		} 
		else if (headerText == "_OύX") { 
			p[iCastleID]._OύX = Convert::ToByte(svalue); 
		} 
	} 
//-------------------------------------------------- p-------------------------------------------------


//-------------------------------------------------- pt-------------------------------------------------
private: 

	TabPage^ tpCastleAdd;
	DataGridView^ dgvCastleAdd;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleCastleAdd = {

		"yzpz", 
		"ԍ",
		"nynԍz",
		"ő΍10",
		"ő古ƒl",
		"wʒu",
		"xʒu",
		"Obhʒu.w",
		"Obhʒu.x",
		"Get_s{"
	}; 

	void dgvCastleAdd_Init() {
		tpCastleAdd = gcnew TabPage();
		tpCastleAdd->Text = "pt";
		tpCastleAdd->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpCastleAdd);


		// f[^ObhŜ̃CX^X 
		dgvCastleAdd = gcnew DataGridView();
		dgvCastleAdd->Size = tpCastleAdd->Size;
		dgvCastleAdd->ScrollBars = ::ScrollBars::Both;
		dgvCastleAdd->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleCastleAdd->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleCastleAdd[i]; 

			if ( i <= 1 ) {
				dgvtbc->Frozen = true; // OR炢͌Œ肷B
			}
			// Obhr[ɏcƂĒǉB 
			dgvCastleAdd->Columns->Add(dgvtbc); 
		} 

		dgvCastleAdd_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvCastleAdd->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvCastleAdd_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpCastleAdd->Controls->Add(dgvCastleAdd);
	} 

private: 
	void dgvCastleAdd_DataImport() { 

		dgvCastleAdd->Rows->Clear();

		for ( int i=0; i<ő吔::::z; i++) {

			Obhʒu^ pos = Get_Obhʒu(i);
			int is{ԍ = Get_s{ԍ(i);

			dgvCastleAdd->Rows->Add( 
				i,
				i+1,

				pt[i].nynԍz,
				pt[i].ő΍10,
				pt[i].ő古ƒl,
				pt[i].wʒu,
				pt[i].xʒu,
				pos.w,
				pos.x,
				gcnew String( Get_s{(is{ԍ).c_str() )
			); 
		} 
	} 

	void dgvCastleAdd_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvCastleAdd->Columns[e->ColumnIndex]->HeaderText;



		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlAԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iCastleID = Convert::ToInt32(dgvCastleAdd[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvCastleAdd[e->ColumnIndex, e->RowIndex]->Value->ToString();



		if (headerText == "nynԍz") { 
			pt[iCastleID].nynԍz = Convert::ToByte(svalue); 
		} 
		else if (headerText == "ő΍10") { 
			pt[iCastleID].ő΍10 = Convert::ToByte(svalue); 
		} 
		else if (headerText == "ő古ƒl") { 
			pt[iCastleID].ő古ƒl = Convert::ToByte(svalue); 
		} 
		else if (headerText == "wʒu") { 
			pt[iCastleID].wʒu = Convert::ToByte(svalue); 
		} 
		else if (headerText == "xʒu") { 
			pt[iCastleID].xʒu = Convert::ToByte(svalue); 
		} 
	} 
//-------------------------------------------------- pt-------------------------------------------------


//-------------------------------------------------- pn-------------------------------------------------
private: 

	TabPage^ tpChiiki;
	DataGridView^ dgvChiiki;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleChiiki = {

		"yzpz", 
		"nԍ",

		"Get_n於",
		"n̏P",
		"n̏Q",
		"n̏R",
		"n̏S",
		"n̏T",
		"n̏U",
		"n̏V",
		"n̏W",
	}; 

	void dgvChiiki_Init() {
		tpChiiki = gcnew TabPage();
		tpChiiki->Text = "pn";
		tpChiiki->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpChiiki);


		// f[^ObhŜ̃CX^X 
		dgvChiiki = gcnew DataGridView();
		dgvChiiki->Size = tpChiiki->Size;
		dgvChiiki->ScrollBars = ::ScrollBars::Both;
		dgvChiiki->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleChiiki->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleChiiki[i]; 

			if ( i <= 1 ) {
				dgvtbc->Frozen = true; // OR炢͌Œ肷B
			}
			// Obhr[ɏcƂĒǉB 
			dgvChiiki->Columns->Add(dgvtbc); 
		} 

		dgvChiiki_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvChiiki->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvChiiki_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpChiiki->Controls->Add(dgvChiiki);
	} 

private: 
	void dgvChiiki_DataImport() { 

		dgvChiiki->Rows->Clear();

		for ( int i=0; i<ő吔::n::z; i++) {

			Obhʒu^ pos = Get_Obhʒu(i);
			int is{ԍ = Get_s{ԍ(i);


			dgvChiiki->Rows->Add( 
				i,
				i+1,
				gcnew String( Get_n於(i).c_str() ),

				pn[i].n̏Pyԍz,
				pn[i].n̏Qyԍz,
				pn[i].n̏Ryԍz,
				pn[i].n̏Syԍz,
				pn[i].n̏Tyԍz,
				pn[i].n̏Uyԍz,
				pn[i].n̏Vyԍz,
				pn[i].n̏Wyԍz
			); 
		} 
	} 

	void dgvChiiki_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvChiiki->Columns[e->ColumnIndex]->HeaderText;



		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlAԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iChiikiID = Convert::ToInt32(dgvChiiki[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvChiiki[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "n̏Pyԍz") { 
			pn[iChiikiID].n̏Pyԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "n̏Qyԍz") { 
			pn[iChiikiID].n̏Qyԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "n̏Ryԍz") { 
			pn[iChiikiID].n̏Ryԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "n̏Syԍz") { 
			pn[iChiikiID].n̏Syԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "n̏Tyԍz") { 
			pn[iChiikiID].n̏Tyԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "n̏Uyԍz") { 
			pn[iChiikiID].n̏Uyԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "n̏Vyԍz") { 
			pn[iChiikiID].n̏Vyԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "n̏Wyԍz") { 
			pn[iChiikiID].n̏Wyԍz = Convert::ToUInt16(svalue); 
		} 
	} 
//-------------------------------------------------- pn-------------------------------------------------


//-------------------------------------------------- pʏ-------------------------------------------------
private: 

	TabPage^ tpKanni;
	DataGridView^ dgvKanni;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleKanni = {
		"yzpz", 
		"ʔԍ",
		"Get_ʖ",
		"ʊK",
		"Lyԍz",
		"㏸l",
	}; 

	void dgvKanni_Init() {
		tpKanni = gcnew TabPage();
		tpKanni->Text = "pʏ";
		tpKanni->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpKanni);


		// f[^ObhŜ̃CX^X 
		dgvKanni = gcnew DataGridView();
		dgvKanni->Size = tpKanni->Size;
		dgvKanni->ScrollBars = ::ScrollBars::Both;
		dgvKanni->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleKanni->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleKanni[i]; 

			if ( i <= 1 ) {
				dgvtbc->Frozen = true; // OR炢͌Œ肷B
			}
			// Obhr[ɏcƂĒǉB 
			dgvKanni->Columns->Add(dgvtbc); 
		} 

		dgvKanni_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvKanni->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvKanni_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpKanni->Controls->Add(dgvKanni);
	} 

private: 
	void dgvKanni_DataImport() {

		dgvKanni->Rows->Clear();

		for ( int i=0; i<ő吔::ʏ::z; i++) { 
			dgvKanni->Rows->Add( 
				i,
				i+1,
				gcnew String(Get_ʖ(i).c_str()),
				pʏ[i].ʊK,
				pʏ[i].Lyԍz,
				pʏ[i].㏸l
			); 
		} 
	} 

	void dgvKanni_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvKanni->Columns[e->ColumnIndex]->HeaderText;



		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlA喼ԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iKanniID = Convert::ToInt32(dgvKanni[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvKanni[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "Get_ʖ") {
			char szKanni[32] = "";
			wsprintf(szKanni, "%s", svalue);
			Set_ʖ(iKanniID, szKanni);
		} 
		else if (headerText == "ʊK") { 
			pʏ[iKanniID].ʊK = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Lyԍz") { 
			pʏ[iKanniID].Lyԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "㏸l") { 
			pʏ[iKanniID].㏸l = Convert::ToByte(svalue); 
		} 
	} 


//-------------------------------------------------- pʏ-------------------------------------------------


//-------------------------------------------------- pƕ-------------------------------------------------
private: 

	TabPage^ tpKahou;
	DataGridView^ dgvKahou;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleKahou = {
		"yzpz", 
		"ƕԍ",
		"Get_ƕ",
		"ƕ󕪗",
		"ƕ摜",
		"Lyԍz",
		"㏸l",
		"o",
		"",
	}; 

	void dgvKahou_Init() {
		tpKahou = gcnew TabPage();
		tpKahou->Text = "pƕ";
		tpKahou->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpKahou);


		// f[^ObhŜ̃CX^X 
		dgvKahou = gcnew DataGridView();
		dgvKahou->Size = tpKahou->Size;
		dgvKahou->ScrollBars = ::ScrollBars::Both;
		dgvKahou->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleKahou->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleKahou[i]; 

			if ( i <= 1 ) {
				dgvtbc->Frozen = true; // OR炢͌Œ肷B
			}
			// Obhr[ɏcƂĒǉB 
			dgvKahou->Columns->Add(dgvtbc); 
		} 

		dgvKahou_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvKahou->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvKahou_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpKahou->Controls->Add(dgvKahou);
	} 

private: 
	void dgvKahou_DataImport() {

		dgvKahou->Rows->Clear();

		for ( int i=0; i<ő吔::ƕ::z; i++) { 
			dgvKahou->Rows->Add( 
				i,
				i+1,
				gcnew String(Get_ƕ(i).c_str()),
				pƕ[i].ƕ󕪗,
				pƕ[i].ƕ摜,
				pƕ[i].Lyԍz,
				pƕ[i].㏸l,
				pƕ[i].o,
				pƕ[i].
				); 
		} 
	} 

	void dgvKahou_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvKahou->Columns[e->ColumnIndex]->HeaderText;



		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlA喼ԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iKahouID = Convert::ToInt32(dgvKahou[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvKahou[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "Get_ƕ") {
			char szKahou[32] = "";
			wsprintf(szKahou, "%s", svalue);
			Set_ƕ(iKahouID, szKahou);
		} 

		else if (headerText == "ƕ󕪗") { 
			pƕ[iKahouID].ƕ󕪗 = Convert::ToByte(svalue); 
		} 
		else if (headerText == "ƕ摜") { 
			pƕ[iKahouID].ƕ摜 = Convert::ToByte(svalue); 
		} 
		else if (headerText == "Lyԍz") { 
			pƕ[iKahouID].Lyԍz = Convert::ToUInt16(svalue); 
		} 
		else if (headerText == "㏸l") { 
			pƕ[iKahouID].㏸l = Convert::ToByte(svalue); 
		} 
		else if (headerText == "o") { 
			pƕ[iKahouID].o = Convert::ToByte(svalue); 
		} 
		else if (headerText == "") { 
			pƕ[iKahouID]. = Convert::ToByte(svalue); 
		} 
	} 


//-------------------------------------------------- pƕ-------------------------------------------------


//-------------------------------------------------- p-------------------------------------------------
private: 

	TabPage^ tpSoba;
	DataGridView^ dgvSoba;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleSoba = {
		"đ", 
		"SC",
		"n",
		"",
	}; 


	void dgvSoba_Init() {
		tpSoba = gcnew TabPage();
		tpSoba->Text = "p";
		tpSoba->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpSoba);


		// f[^ObhŜ̃CX^X 
		dgvSoba = gcnew DataGridView();
		dgvSoba->Size = tpSoba->Size;
		dgvSoba->ScrollBars = ::ScrollBars::Both;
		dgvSoba->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleSoba->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleSoba[i]; 

			// Obhr[ɏcƂĒǉB 
			dgvSoba->Columns->Add(dgvtbc); 
		} 

		dgvSoba_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvSoba->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvSoba_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpSoba->Controls->Add(dgvSoba);
	} 

private: 
	void dgvSoba_DataImport() { 

		dgvSoba->Rows->Clear();

		dgvSoba->Rows->Add(
			p.đ,
			p.SC,
			p.n,
			p.
		); 
	} 

	void dgvSoba_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvSoba->Columns[e->ColumnIndex]->HeaderText;

		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlAԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iBushouID = Convert::ToInt32(dgvSoba[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvSoba[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "đ") { 
			Set_đ( Convert::ToUInt16(svalue) ); 
		} 
		else if (headerText == "SC") { 
			Set_SC( Convert::ToUInt16(svalue) ); 
		} 
		else if (headerText == "n") { 
			Set_n( Convert::ToUInt16(svalue) ); 
		} 
		else if (headerText == "") { 
			Set_( Convert::ToUInt16(svalue) ); 
		} 
	} 


//-------------------------------------------------- p-------------------------------------------------



//-------------------------------------------------- pij-------------------------------------------------
private: 

	TabPage^ tpBattleUnit;
	DataGridView^ dgvBattleUnit;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleBattleUnit = {
		"ԍ",
		"sc̋A",
		"wbNX.w",
		"wbNX.x",
		"ړ͎c",
		"",
		"Is_sρs푈ʁt",
		"pːЏ[ix].펀",
		"pːЏ[ix].ދp",
		"ow",
		"\}bvɏow",
	}; 

	void dgvBattleUnit_Init() {
		tpBattleUnit = gcnew TabPage();
		tpBattleUnit->Text = "ij";
		tpBattleUnit->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpBattleUnit);


		// f[^ObhŜ̃CX^X 
		dgvBattleUnit = gcnew DataGridView();
		dgvBattleUnit->Size = tpBattleUnit->Size;
		dgvBattleUnit->ScrollBars = ::ScrollBars::Both;
		dgvBattleUnit->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleBattleUnit->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleBattleUnit[i]; 

			if ( i == 0 ) {
				dgvtbc->Frozen = true; // OR炢͌Œ肷B
			}
			// Obhr[ɏcƂĒǉB 
			dgvBattleUnit->Columns->Add(dgvtbc); 
		} 

		dgvBattleUnit_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvBattleUnit->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvBattleUnit_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpBattleUnit->Controls->Add(dgvBattleUnit);
	} 

private: 
	void dgvBattleUnit_DataImport() {

		dgvBattleUnit->Rows->Clear();

		ԍXg^ Xg = Get_ԍXgyzpz();

		for each ( int iBushouID in Xg ) {

			wbNXʒu^ pos = Get_̖wbNXʒu(iBushouID);

			ԍXg^ ow = Get_ow̕ԍXgyzpz();
			ԍXg^  = Get_ow̕ԍXgyzpzs\}bvt();

			int cntow = std::count(ow.begin(), ow.end(), iBushouID);
			int cnt = std::count(.begin(), .end(), iBushouID);

			dgvBattleUnit->Rows->Add(
				iBushouID + 1,
				Get_sc̋A(iBushouID),
				pos.w,
				pos.x,
				Get_ړc(iBushouID),
				(int)Get_(iBushouID),
				(int)Is_sρs푈ʁt(iBushouID),
				pːЏ[iBushouID].펀,
				pːЏ[iBushouID].ދp,
				(int)(cntow>0),
				(int)(cnt>0)
			);

		}
	} 

	void dgvBattleUnit_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvBattleUnit->Columns[e->ColumnIndex]->HeaderText;

		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlA喼ԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iBattleUnitID = Convert::ToInt32(dgvBattleUnit[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 
		int iBushouID = iBattleUnitID-1;

		String^ svalue = dgvBattleUnit[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "") {
			if ( 0 <= iBushouID && iBushouID < ő吔::::z) {
				Set_( iBushouID, Convert::ToUInt16(svalue) ); 
			}
		} 
	} 


//-------------------------------------------------- pij-------------------------------------------------



//-------------------------------------------------- pݒ-------------------------------------------------
private: 

	TabPage^ tpSettings;
	DataGridView^ dgvSettings;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleSettings = {
		"ʉ", 
		"y",
		"̐푈",
		"[r[",
		"\x",
		"Փx",
	}; 


	void dgvSettings_Init() {
		tpSettings = gcnew TabPage();
		tpSettings->Text = "pݒ";
		tpSettings->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpSettings);


		// f[^ObhŜ̃CX^X 
		dgvSettings = gcnew DataGridView();
		dgvSettings->Size = tpSettings->Size;
		dgvSettings->ScrollBars = ::ScrollBars::Both;
		dgvSettings->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleSettings->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleSettings[i]; 

			// Obhr[ɏcƂĒǉB 
			dgvSettings->Columns->Add(dgvtbc); 
		} 

		dgvSettings_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvSettings->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvSettings_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpSettings->Controls->Add(dgvSettings);
	} 

private: 
	void dgvSettings_DataImport() { 

		dgvSettings->Rows->Clear();

		dgvSettings->Rows->Add(
			pݒ.ʉ,
			pݒ.y,
			pݒ.̐푈,
			BOOL(pݒ.[r[ == [r[::nm),
			pݒ.\x,
			pݒ.Փx
		); 
	} 

	void dgvSettings_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvSettings->Columns[e->ColumnIndex]->HeaderText;

		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlAݒԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iBushouID = Convert::ToInt32(dgvSettings[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvSettings[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "ʉ") { 
			pݒ.ʉ = Convert::ToByte(svalue);
		} 
		else if (headerText == "y") { 
			pݒ.y = Convert::ToByte(svalue);
		} 
		else if (headerText == "̐푈") { 
			pݒ.̐푈 = Convert::ToByte(svalue);
		} 
		else if (headerText == "[r[") { 
			pݒ.[r[ = int(Convert::ToByte(svalue) == [r[::nm);
		} 
		else if (headerText == "\x") { 
			pݒ.\x = Convert::ToByte(svalue);
		} 
		else if (headerText == "Փx") { 
			pݒ.Փx = Convert::ToByte(svalue);
		} 
	} 

//-------------------------------------------------- pݒ-------------------------------------------------


//-------------------------------------------------- pݒg-------------------------------------------------
private: 

	TabPage^ tpSettingsEx;
	DataGridView^ dgvSettingsEx;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleSettingsEx = {
		"N\", 
		"\ʒuL",
		"\ؑփ}bv",
		"푈px",
		"vpx",
		"Spx",
		"̐푈",
		"ҏW@\",
		"\",
		"su",
		"Pu",
	}; 


	void dgvSettingsEx_Init() {
		tpSettingsEx = gcnew TabPage();
		tpSettingsEx->Text = "pݒg";
		tpSettingsEx->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpSettingsEx);


		// f[^ObhŜ̃CX^X 
		dgvSettingsEx = gcnew DataGridView();
		dgvSettingsEx->Size = tpSettingsEx->Size;
		dgvSettingsEx->ScrollBars = ::ScrollBars::Both;
		dgvSettingsEx->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleSettingsEx->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleSettingsEx[i]; 

			// Obhr[ɏcƂĒǉB 
			dgvSettingsEx->Columns->Add(dgvtbc); 
		} 

		dgvSettingsEx_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvSettingsEx->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvSettingsEx_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpSettingsEx->Controls->Add(dgvSettingsEx);
	} 

private: 
	void dgvSettingsEx_DataImport() { 

		dgvSettingsEx->Rows->Clear();

		dgvSettingsEx->Rows->Add(
			pݒg.N\,
			pݒg.\ʒuL,
			pݒg.\ؑփ}bv,
			pݒg.푈px,
			pݒg.vpx,
			pݒg.Spx,
			pݒg.̐푈,
			pݒg.ҏW@\,
			pݒg.\,
			pݒg.su,
			pݒg.Pu
		); 
	} 

	void dgvSettingsEx_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvSettingsEx->Columns[e->ColumnIndex]->HeaderText;

		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlAݒԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iBushouID = Convert::ToInt32(dgvSettingsEx[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvSettingsEx[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "N\") { 
			pݒg.N\ = Convert::ToByte(svalue);
		} 
		else if (headerText == "\ʒuL") { 
			pݒg.\ʒuL = Convert::ToByte(svalue);
		} 
		else if (headerText == "\ؑփ}bv") { 
			pݒg.\ؑփ}bv = Convert::ToByte(svalue);
		} 
		else if (headerText == "푈px") { 
			pݒg.푈px = Convert::ToByte(svalue);
		} 
		else if (headerText == "vpx") { 
			pݒg.vpx = Convert::ToByte(svalue);
		} 
		else if (headerText == "Spx") { 
			pݒg.Spx = Convert::ToByte(svalue);
		} 
		else if (headerText == "̐푈") { 
			pݒg.̐푈 = Convert::ToByte(svalue);
		} 
		else if (headerText == "ҏW@\") { 
			pݒg.ҏW@\ = Convert::ToByte(svalue);
		} 
		else if (headerText == "\") { 
			pݒg.\ = Convert::ToByte(svalue);
		} 
		else if (headerText == "su") { 
			pݒg.su = Convert::ToByte(svalue);
		} 
		else if (headerText == "Pu") { 
			pݒg.Pu = Convert::ToByte(svalue);
		} 
	} 

//-------------------------------------------------- pݒg-------------------------------------------------





//-------------------------------------------------- pVC-------------------------------------------------
private: 

	TabPage^ tpWeather;
	DataGridView^ dgvWeather;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleWeather = {
		"Get_VC",
		""
	}; 

	void dgvWeather_Init() {
		tpWeather = gcnew TabPage();
		tpWeather->Text = "pVC";
		tpWeather->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpWeather);


		// f[^ObhŜ̃CX^X 
		dgvWeather = gcnew DataGridView();
		dgvWeather->Size = tpWeather->Size;
		dgvWeather->ScrollBars = ::ScrollBars::Both;
		dgvWeather->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleWeather->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleWeather[i]; 

			// Obhr[ɏcƂĒǉB 
			dgvWeather->Columns->Add(dgvtbc); 
		} 

		dgvWeather_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvWeather->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvWeather_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpWeather->Controls->Add(dgvWeather);
	} 

private: 
	void dgvWeather_DataImport() {
		dgvWeather[0, 0]->Value = Get_VC();
	} 

	void dgvWeather_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvWeather->Columns[e->ColumnIndex]->HeaderText;

		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlAԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iCastleID = Convert::ToInt32(dgvWeather[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvWeather[e->ColumnIndex, e->RowIndex]->Value->ToString();
	} 
//-------------------------------------------------- pVC-------------------------------------------------


//-------------------------------------------------- py-------------------------------------------------
private: 

	TabPage^ tpBGM;
	DataGridView^ dgvBGM;  // f[^Obhr[^B GNẐ悤Ɋiq̃f[^\ł邽߁Aɂ悭pB 

	// .NETString^^vfƂA.NET̔zarray^^B 
	static cli::array<String^>^ colTitleBGM = {
		"Get_Đyԍ",
		""
	}; 

	void dgvBGM_Init() {
		tpBGM = gcnew TabPage();
		tpBGM->Text = "py";
		tpBGM->Size = tcME->ClientSize;
		tcME->TabPages->Add(tpBGM);


		// f[^ObhŜ̃CX^X 
		dgvBGM = gcnew DataGridView();
		dgvBGM->Size = tpBGM->Size;
		dgvBGM->ScrollBars = ::ScrollBars::Both;
		dgvBGM->AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode::AllCells; // eJ̉̓RecɉĎ 

		// -------------- f[^Obh́ucɑJuWFNgvƁAueJ̃^Cgv̕ZbeBOB 

		for (int i=0; i < colTitleBGM->Length; i++) {

			// c̃IuWFNg 
			DataGridViewTextBoxColumn^ dgvtbc = gcnew DataGridViewTextBoxColumn(); 
			// ^Cgݒ 
			dgvtbc->HeaderText = colTitleBGM[i]; 

			// Obhr[ɏcƂĒǉB 
			dgvBGM->Columns->Add(dgvtbc); 
		} 

		dgvBGM_DataImport(); 

		// f[^Obh̃ZҏW̃Cxgnho^B 
		dgvBGM->CellValueChanged += gcnew DataGridViewCellEventHandler(this, &MemoryEditorForm::dgvBGM_CellValueChanged); 

		// f[^Obhr[tH[ɏ 
		tpBGM->Controls->Add(dgvBGM);
	} 

private: 
	void dgvBGM_DataImport() {
		dgvBGM[0, 0]->Value = Get_Đyԍ();
	} 

	void dgvBGM_CellValueChanged(Object^ sender, DataGridViewCellEventArgs^ e)   { 
		// CxgIuWFNg(=sender) ̓f[^Obhr[^Ȃ̂ŁAf[^Obhr[^ƂĎ󂯎āc 

		String^ headerText = dgvBGM->Columns[e->ColumnIndex]->HeaderText;



		// ҏWŹusv̈ԍ̃JłuindexID(=0)vɓĂlAԍyzpzłB 
		// [Uœ͂̂͑SĕɂȂĂ܂B 
		// vODgvDataImportł͍ŏ͐lœĂB 
		// āAǂ̂悤ȃf[^^łǂ悤ɁAToStringɂĂׂĕɒAConvert::***ɂāA^ɂB 
		int iCastleID = Convert::ToInt32(dgvBGM[0, e->RowIndex]->Value->ToString()); // indexIDԍcolumn0 

		String^ svalue = dgvBGM[e->ColumnIndex, e->RowIndex]->Value->ToString();

		if (headerText == "Get_Đyԍ") {
			if ( svalue == "" ) {
				y~();
			} else {
				yĐ( Convert::ToByte(svalue) ); 
			}
		} 
	} 
//-------------------------------------------------- py-------------------------------------------------


};

